package door

// Need net, flag for setupSockets
import (
	"testing"
)

func TestFIFOEmpty(t *testing.T) {
	buffer := NewFIFOBuffer[rune](3)

	defer func() {
		if r := recover(); r == nil {
			t.Error("Pop of empty FIFO Buffer did not panic.")
		}
	}()

	buffer.Push(rune(1))
	x := buffer.Pop()
	if x != rune(1) {
		t.Errorf("Buffer did not return expected value 1: %d", x)
	}

	_ = buffer.Pop()
}

func TestFIFOOverflow(t *testing.T) {
	buffer := NewFIFOBuffer[rune](3)

	defer func() {
		if r := recover(); r == nil {
			t.Error("Pop of empty FIFO Buffer did not panic.")
		}
	}()

	buffer.Push(rune(1))
	buffer.Push(rune(2))
	buffer.Push(rune(3))
	buffer.Push(rune(4))

}
